   import java.awt.*; 
import java.awt.image.*; 
import java.io.*; 
import java.util.*;
   import javax.imageio.*; 
import javax.imageio.stream.*;
    public class ColorImage {
   // is stored in an unsupported file format (currently only .GIF, .JPG, and .PNG are supported by Sun).
       public static int[][][] read(String filename) throws Exception {
         String ext = filename.substring(filename.indexOf('.')+1);
         File fileImage = new File(filename);
         Iterator imageReaders = ImageIO.getImageReadersBySuffix(ext);
         ImageReader imageReader;
         if (imageReaders.hasNext())
            imageReader = (ImageReader) imageReaders.next();
         else 
            throw new IIOException("Unsupported image format");
         FileImageInputStream imageInputStream = new FileImageInputStream(fileImage);
         imageReader.setInput(imageInputStream);
         int width = imageReader.getWidth(0);
         int height = imageReader.getHeight(0);
         BufferedImage bufImage = imageReader.read(0);
         imageInputStream.close();
         WritableRaster wRaster = bufImage.getRaster();
         int[][][] samples = new int[height][width][3];
         for (int row = 0; row < height; row++)
            for (int col = 0; col < width; col++) {
               samples[row][col][0] = wRaster.getSample(col,row,0);
               samples[row][col][1] = wRaster.getSample(col,row,1);
               samples[row][col][2] = wRaster.getSample(col,row,2);
            }
                return samples;

      }//read
      
   // Write the image stored in the 'samples' array to the specified file. The file name suffix should be 
   // a supported image file format (currently either .JPG or .PNG).
       public static void write(String filename, int[][][] samples) throws Exception {
         String ext = filename.substring(filename.indexOf('.')+1);
         File fileImage = new File(filename);
         Iterator imageWriters = ImageIO.getImageWritersBySuffix(ext);
         ImageWriter imageWriter;
         if (imageWriters.hasNext())
            imageWriter = (ImageWriter) imageWriters.next();
         else 
            throw new IIOException("Unsupported image format");
         FileImageOutputStream imageOutputStream = new FileImageOutputStream(fileImage);
         imageWriter.setOutput(imageOutputStream);
         BufferedImage bufImage = createBufferedImage(samples);
         imageWriter.write(bufImage);
         imageOutputStream.close();
      }//write
   
       public static void draw(Graphics gc, int x, int y, int[][][] samples){
         BufferedImage bufImage = createBufferedImage(samples);
         gc.drawImage(bufImage, x, y, null);
      }//draw
      
       private static BufferedImage createBufferedImage(int[][][] samples) {
                int width = samples[0].length;
                int height = samples.length;
         BufferedImage bufImage = new BufferedImage(width, height,  BufferedImage.TYPE_3BYTE_BGR);
         WritableRaster wRaster = bufImage.getRaster();

         for (int row = 0; row < height; row++)
            for (int col = 0; col < width; col++) {
               wRaster.setSample(col, row, 0, samples[row][col][0]);
               wRaster.setSample(col, row, 1, samples[row][col][1]);
               wRaster.setSample(col, row, 2, samples[row][col][2]);
            }
         return bufImage;
      }//createBufferedImage
}
